/*
 * TD Langage C - Institut d'Optique - 1A / S5
 * 	Bibliothque de fonctions / Tableaux 1D
 * 	Auteur : Julien VILLEMEJANE / 2018
 */

#ifndef TAB1D_H_INCLUDED
#define TAB1D_H_INCLUDED

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>

/*
 * afficheTabDbl : Affiche dans la console un tableau de double
 * 	ENTREES :
 *		t[] : adresse du tableau  afficher (type double)
 *      dim : dimension du tableau  afficher (entier)
 * 	SORTIE :
 * 		Affichage sur la console
 * 	Auteur : Julien Villemejane / Cration : 05/07/2018
 */
void afficheTabDbl(double t[], int dim);

/*
 * sommeTabDbl : Calcule la somme des lments d'un tableau de double
 * 	ENTREES :
 *		t[] : adresse du tableau  afficher (type double)
 *      dim : dimension du tableau  afficher (entier)
 * 	SORTIE :
 * 		Somme des lments (double)
 * 	Auteur : Julien Villemejane / Cration : 05/07/2018
 */
double sommeTabDbl(double t[], int dim);

/*
 * remplissageTabIntAlea : Remplit alatoirement un tableau d'entiers 
 * 				entre min et max
 * 	ENTREES :
 *		t[] : adresse du tableau  afficher (type int)
 *      dim : dimension du tableau  afficher (entier)
 *      mini : valeur minimale du tableau (entier)
 *      maxi : valeur maximale du tableau (entier)
 * 	SORTIE :
 * 		Tableau t rempli
 * 	Auteur : Julien Villemejane / Cration : 04/09/2018
 */
void remplissageTabIntAlea(int t[], int dim, int mini, int maxi);

/*
 * afficheTabInt : Affiche dans la console un tableau d'entiers
 * 	ENTREES :
 *		t[] : adresse du tableau  afficher (type int)
 *      dim : dimension du tableau  afficher (entier)
 * 	SORTIE :
 * 		Affichage sur la console
 * 	Auteur : Julien Villemejane / Cration : 05/07/2018
 */
void afficheTabInt(int t[], int dim);

/*
 * sommeTabInt : Calcule la somme des lments d'un tableau d'entiers
 * 	ENTREES :
 *		t[] : adresse du tableau  analyser (type int)
 *      dim : dimension du tableau  analyser (entier)
 * 	SORTIE :
 * 		Somme des lments (int)
 * 	Auteur : Julien Villemejane / Cration : 05/07/2018
 */
int sommeTabInt(int t[], int dim);

/*
 * moyTabInt : Calcule la moyenne des lments d'un tableau d'entiers
 * 	ENTREES :
 *		t[] : adresse du tableau  analyser (type int)
 *      dim : dimension du tableau  analyser (entier)
 * 	SORTIE :
 * 		Moyenne des lments (double)
 * 	Auteur : Julien Villemejane / Cration : 05/07/2018
 */
double moyTabInt(int t[], int dim);

/*
 * stdDevTabInt : Calcule l'cart-type des lments d'un tableau d'entiers
 * 	ENTREES :
 *		t[] : adresse du tableau  analyser (type int)
 *      dim : dimension du tableau  analyser (entier)
 * 	SORTIE :
 * 		Ecart-type des lments (double)
 * 	Auteur : Julien Villemejane / Cration : 05/07/2018
 */
double stdDevTabInt(int t[], int dim);

/*
 * minTabInt : Retourne la valeur minimale d'un tableau d'entiers
 *  ENTREES :
 *		t[] : adresse du tableau  analyser (type int)
 *      dim : dimension du tableau  analyser (entier)
 * 	SORTIE :
 * 		valeur minimale du tableau (int)
 * 	Auteur : Julien Villemejane / Cration : 05/07/2018
 */
int minTabInt(int t[], int dim);

/*
 * maxTabInt : Retourne la valeur maximale d'un tableau d'entiers
 *  ENTREES :
 *		t[] : adresse du tableau  analyser (type int)
 *      dim : dimension du tableau  analyser (entier)
 * 	SORTIE :
 * 		valeur maximale du tableau (int)
 * 	Auteur : Julien Villemejane / Cration : 05/07/2018
 */
int maxTabInt(int t[], int dim);

#endif // TAB1D_H_INCLUDED
